Package net.sf.saxon.pattern

## Class MultipleNodeKindTest

- java.lang.Object
- - net.sf.saxon.pattern.NodeTest
  - - net.sf.saxon.pattern.MultipleNodeKindTest

- All Implemented Interfaces:
    `java.util.function.Predicate<NodeInfo>`, `ItemType`, `ItemType.WithSequenceTypeCache`

      public final class MultipleNodeKindTest
      extends NodeTest

  An MultipleNodeKindTest is a nodetest that matches nodes belonging to any subset of possible node kinds, for example element and document nodes, or attribute and namespace nodes

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.type.ItemType

      `ItemType.WithSequenceTypeCache`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static MultipleNodeKindTest` | `CHILD_NODE` |
    `static MultipleNodeKindTest` | `DOC_ELEM_ATTR` |
    `static MultipleNodeKindTest` | `LEAF` |
    `static MultipleNodeKindTest` | `PARENT_NODE` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `MultipleNodeKindTest​(UType u)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `equals​(java.lang.Object obj)` |
    `double` | `getDefaultPriority()` | Determine the default priority to use if this pattern appears as a match pattern for a template with no explicit priority attribute.
    `java.util.function.IntPredicate` | `getMatcher​(NodeVectorTree tree)` | Get a matching function that can be used to test whether numbered nodes in a TinyTree or DominoTree satisfy the node test.
    `UType` | `getUType()` | Get the corresponding `UType`.
    `int` | `hashCode()` | Returns a hash code value for the object.
    `boolean` | `matches​(int nodeKind, NodeName name, SchemaType annotation)` | Test whether this node test is satisfied by a given node.
    `boolean` | `test​(NodeInfo node)` | Test whether this node test is satisfied by a given node.
    `java.lang.String` | `toExportString()` | Return a string representation of this ItemType suitable for use in stylesheet export files.
    `java.lang.String` | `toShortString()` |
    `java.lang.String` | `toString()` |

    - ### Methods inherited from class net.sf.saxon.pattern.NodeTest

      `copy, explainMismatch, getAtomizedItemType, getBasicAlphaCode, getContentType, getFingerprint, getGenre, getMatchingNodeName, getPrimitiveItemType, getPrimitiveType, getRequiredNodeNames, isAtomicType, isAtomizable, isNillable, isPlainType, matches, one, oneOrMore, zeroOrMore, zeroOrOne`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.type.ItemType

      `getFullAlphaCode, getNormalizedDefaultPriority, isTrueItemType`

    - ### Methods inherited from interface java.util.function.Predicate

      `and, negate, or`

- - ### Field Detail

    - #### PARENT_NODE

          public static final MultipleNodeKindTest PARENT_NODE

    - #### DOC_ELEM_ATTR

          public static final MultipleNodeKindTest DOC_ELEM_ATTR

    - #### LEAF

          public static final MultipleNodeKindTest LEAF

    - #### CHILD_NODE

          public static final MultipleNodeKindTest CHILD_NODE

  - ### Constructor Detail

    - #### MultipleNodeKindTest

          public MultipleNodeKindTest​(UType u)

  - ### Method Detail

    - #### getUType

          public UType getUType()

      Get the corresponding `UType`. A UType is a union of primitive item types.
      Returns:
        the smallest UType that subsumes this item type

    - #### matches

          public boolean matches​(int nodeKind,
                                 NodeName name,
                                 SchemaType annotation)

      Test whether this node test is satisfied by a given node. This method is only fully supported for a subset of NodeTests, because it doesn't provide all the information needed to evaluate all node tests. In particular (a) it can't be used to evaluate a node test of the form element(N,T) or schema-element(E) where it is necessary to know whether the node is nilled, and (b) it can't be used to evaluate a node test of the form document-node(element(X)). This in practice means that it is used (a) to evaluate the simple node tests found in the XPath 1.0 subset used in XML Schema, and (b) to evaluate node tests where the node kind is known to be an attribute.
      Specified by:
        `matches` in class `NodeTest`
      Parameters:
        `nodeKind` - The kind of node to be matched
        `name` - identifies the expanded name of the node to be matched. The value should be null for a node with no name.
        `annotation` - The actual content type of the node
      Returns:
        true if the node matches this node test

    - #### getMatcher

          public java.util.function.IntPredicate getMatcher​(NodeVectorTree tree)

      Description copied from class: `NodeTest`
      Get a matching function that can be used to test whether numbered nodes in a TinyTree or DominoTree satisfy the node test. (Calling this matcher must give the same result as calling `matchesNode(tree.getNode(nodeNr))`, but it may well be faster).
      Overrides:
        `getMatcher` in class `NodeTest`
      Parameters:
        `tree` - the tree against which the returned function will operate
      Returns:
        an IntPredicate; the matches() method of this predicate takes a node number as input, and returns true if and only if the node identified by this node number matches the node test.

    - #### test

          public boolean test​(NodeInfo node)

      Test whether this node test is satisfied by a given node. This alternative method is used in the case of nodes where calculating the fingerprint is expensive, for example DOM or JDOM nodes.
      Specified by:
        `test` in interface `java.util.function.Predicate<NodeInfo>`
      Overrides:
        `test` in class `NodeTest`
      Parameters:
        `node` - the node to be matched
      Returns:
        true if the node test is satisfied by the supplied node, false otherwise

    - #### getDefaultPriority

          public double getDefaultPriority()

      Determine the default priority to use if this pattern appears as a match pattern for a template with no explicit priority attribute.
      Specified by:
        `getDefaultPriority` in interface `ItemType`
      Specified by:
        `getDefaultPriority` in class `NodeTest`
      Returns:
        the default priority for the pattern

    - #### toString

          public java.lang.String toString()

      Specified by:
        `toString` in interface `ItemType`
      Overrides:
        `toString` in class `java.lang.Object`

    - #### toExportString

          public java.lang.String toExportString()

      Description copied from interface: `ItemType`
      Return a string representation of this ItemType suitable for use in stylesheet export files. This differs from the result of toString() in that it will not contain any references to anonymous types. Note that it may also use the Saxon extended syntax for union types and tuple types. The default implementation returns the result of calling `toString()`.
      Returns:
        the string representation as an instance of the XPath SequenceType construct

    - #### toShortString

          public java.lang.String toShortString()

      Overrides:
        `toShortString` in class `NodeTest`

    - #### hashCode

          public int hashCode()

      Returns a hash code value for the object.
      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### equals

          public boolean equals​(java.lang.Object obj)

      Overrides:
        `equals` in class `java.lang.Object`